## bzip2-1.0.3.tar.bz2

=== Makefile ===
somajor=1.0
sominor=$(somajor).3
SHELL=/bin/sh

# To assist in cross-compiling
CC=gcc
AR=ar
RANLIB=ranlib
LDFLAGS=

BIGFILES=-D_FILE_OFFSET_BITS=64
CFLAGS=-Wall -Winline -O2 -g $(BIGFILES) $(DEBCFLAGS)

# Where you want it installed when you do 'make install'
PREFIX=/usr


OBJS= blocksort.o  \
      huffman.o    \
      crctable.o   \
      randtable.o  \
      compress.o   \
      decompress.o \
      bzlib.o

all: libbz2.a bzip2 bzip2recover # test

bzip2: libbz2.so bzip2.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o bzip2 bzip2.o -L. -lbz2

bzip2recover: bzip2recover.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o bzip2recover bzip2recover.o

libbz2.a: $(OBJS)
	rm -f libbz2.a
	$(AR) cq libbz2.a $(OBJS)
	@if ( test -f $(RANLIB) || test -f /usr/bin/ranlib || \
		test -f /bin/ranlib || test -f /usr/ccs/bin/ranlib ) ; then \
		echo $(RANLIB) libbz2.a ; \
		$(RANLIB) libbz2.a ; \
	fi

libbz2.so: libbz2.so.$(somajor)
	ln -sf $^ $@

libbz2.so.$(somajor): libbz2.so.$(sominor)
	ln -sf $^ $@

libbz2.so.$(sominor): $(OBJS:%.o=%.sho)
	$(CC) -o libbz2.so.$(sominor) -shared \
	  -Wl,-soname,libbz2.so.$(somajor) $^ -lc

%.sho: %.c
	$(CC) $(CFLAGS) -D_REENTRANT -fPIC -o $@ -c $<

%.o: %.c
	$(CC) $(CFLAGS) -D_REENTRANT -o $@ -c $<

check: test
test: bzip2
	@cat words1
	LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH \
	./bzip2 -1  < sample1.ref > sample1.rb2
	LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH \
	./bzip2 -2  < sample2.ref > sample2.rb2
	LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH \
	./bzip2 -3  < sample3.ref > sample3.rb2
	LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH \
	./bzip2 -d  < sample1.bz2 > sample1.tst
	LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH \
	./bzip2 -d  < sample2.bz2 > sample2.tst
	LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH \
	./bzip2 -ds < sample3.bz2 > sample3.tst
	cmp sample1.bz2 sample1.rb2 
	cmp sample2.bz2 sample2.rb2
	cmp sample3.bz2 sample3.rb2
	cmp sample1.tst sample1.ref
	cmp sample2.tst sample2.ref
	cmp sample3.tst sample3.ref
	@cat words3

install: bzip2 bzip2recover libbz2.a
	if ( test ! -d $(PREFIX)/bin ) ; then mkdir -p $(PREFIX)/bin ; fi
	if ( test ! -d $(PREFIX)/lib ) ; then mkdir -p $(PREFIX)/lib ; fi
	if ( test ! -d $(PREFIX)/man ) ; then mkdir -p $(PREFIX)/man ; fi
	if ( test ! -d $(PREFIX)/man/man1 ) ; then mkdir -p $(PREFIX)/man/man1 ; fi
	if ( test ! -d $(PREFIX)/include ) ; then mkdir -p $(PREFIX)/include ; fi
	cp -f bzip2 $(PREFIX)/bin/bzip2
	ln $(PREFIX)/bin/bzip2 $(PREFIX)/bin/bunzip2
	ln $(PREFIX)/bin/bzip2 $(PREFIX)/bin/bzcat
	cp -f bzip2recover $(PREFIX)/bin/bzip2recover
	chmod a+x $(PREFIX)/bin/bzip2
	chmod a+x $(PREFIX)/bin/bunzip2
	chmod a+x $(PREFIX)/bin/bzcat
	chmod a+x $(PREFIX)/bin/bzip2recover
	cp -f bzip2.1 $(PREFIX)/man/man1
	chmod a+r $(PREFIX)/man/man1/bzip2.1
	cp -f bzlib.h $(PREFIX)/include
	chmod a+r $(PREFIX)/include/bzlib.h
	cp -fa libbz2.a libbz2.so* $(PREFIX)/lib
	chmod a+r $(PREFIX)/lib/libbz2.a
	cp -f bzexe $(PREFIX)/bin/bzexe
	chmod a+x $(PREFIX)/bin/bzexe
	cp -f bzgrep $(PREFIX)/bin/bzgrep
	ln $(PREFIX)/bin/bzgrep $(PREFIX)/bin/bzegrep
	ln $(PREFIX)/bin/bzgrep $(PREFIX)/bin/bzfgrep
	chmod a+x $(PREFIX)/bin/bzgrep
	cp -f bzmore $(PREFIX)/bin/bzmore
	ln $(PREFIX)/bin/bzmore $(PREFIX)/bin/bzless
	chmod a+x $(PREFIX)/bin/bzmore
	cp -f bzdiff $(PREFIX)/bin/bzdiff
	ln $(PREFIX)/bin/bzdiff $(PREFIX)/bin/bzcmp
	chmod a+x $(PREFIX)/bin/bzdiff
	cp -f bzexe.1 bzgrep.1 bzmore.1 bzdiff.1 $(PREFIX)/man/man1
	chmod a+r $(PREFIX)/man/man1/bzexe.1
	chmod a+r $(PREFIX)/man/man1/bzgrep.1
	chmod a+r $(PREFIX)/man/man1/bzmore.1
	chmod a+r $(PREFIX)/man/man1/bzdiff.1
	echo ".so man1/bzgrep.1" > $(PREFIX)/man/man1/bzegrep.1
	echo ".so man1/bzgrep.1" > $(PREFIX)/man/man1/bzfgrep.1
	echo ".so man1/bzmore.1" > $(PREFIX)/man/man1/bzless.1
	echo ".so man1/bzdiff.1" > $(PREFIX)/man/man1/bzcmp.1

clean: 
	rm -f *.o *.sho libbz2.a libbz2.so* bzip2 bzip2recover \
	sample1.rb2 sample2.rb2 sample3.rb2 \
	sample1.tst sample2.tst sample3.tst


distclean: clean
	rm -f manual.ps manual.html manual.pdf

DISTNAME=bzip2-1.0.3
dist: check manual
	rm -f $(DISTNAME)
	ln -sf . $(DISTNAME)
	tar cvf $(DISTNAME).tar \
	   $(DISTNAME)/blocksort.c \
	   $(DISTNAME)/huffman.c \
	   $(DISTNAME)/crctable.c \
	   $(DISTNAME)/randtable.c \
	   $(DISTNAME)/compress.c \
	   $(DISTNAME)/decompress.c \
	   $(DISTNAME)/bzlib.c \
	   $(DISTNAME)/bzip2.c \
	   $(DISTNAME)/bzip2recover.c \
	   $(DISTNAME)/bzlib.h \
	   $(DISTNAME)/bzlib_private.h \
	   $(DISTNAME)/Makefile \
	   $(DISTNAME)/LICENSE \
	   $(DISTNAME)/bzip2.1 \
	   $(DISTNAME)/bzip2.1.preformatted \
	   $(DISTNAME)/bzip2.txt \
	   $(DISTNAME)/words0 \
	   $(DISTNAME)/words1 \
	   $(DISTNAME)/words2 \
	   $(DISTNAME)/words3 \
	   $(DISTNAME)/sample1.ref \
	   $(DISTNAME)/sample2.ref \
	   $(DISTNAME)/sample3.ref \
	   $(DISTNAME)/sample1.bz2 \
	   $(DISTNAME)/sample2.bz2 \
	   $(DISTNAME)/sample3.bz2 \
	   $(DISTNAME)/dlltest.c \
	   $(DISTNAME)/manual.html \
	   $(DISTNAME)/manual.pdf \
	   $(DISTNAME)/manual.ps \
	   $(DISTNAME)/README \
	   $(DISTNAME)/README.COMPILATION.PROBLEMS \
	   $(DISTNAME)/README.XML.STUFF \
	   $(DISTNAME)/CHANGES \
	   $(DISTNAME)/libbz2.def \
	   $(DISTNAME)/libbz2.dsp \
	   $(DISTNAME)/dlltest.dsp \
	   $(DISTNAME)/makefile.msc \
	   $(DISTNAME)/Y2K_INFO \
	   $(DISTNAME)/unzcrash.c \
	   $(DISTNAME)/spewG.c \
	   $(DISTNAME)/mk251.c \
	   $(DISTNAME)/bzdiff \
	   $(DISTNAME)/bzdiff.1 \
	   $(DISTNAME)/bzmore \
	   $(DISTNAME)/bzmore.1 \
	   $(DISTNAME)/bzexe \
	   $(DISTNAME)/bzexe.1 \
	   $(DISTNAME)/bzgrep \
	   $(DISTNAME)/bzgrep.1 \
	   $(DISTNAME)/Makefile-libbz2_so \
	   $(DISTNAME)/bz-common.xsl \
	   $(DISTNAME)/bz-fo.xsl \
	   $(DISTNAME)/bz-html.xsl \
	   $(DISTNAME)/bzip.css \
	   $(DISTNAME)/entities.xml \
	   $(DISTNAME)/manual.xml \
	   $(DISTNAME)/format.pl \
	   $(DISTNAME)/xmlproc.sh
	gzip -v $(DISTNAME).tar

# For rebuilding the manual from sources on my SuSE 9.1 box

MANUAL_SRCS= 	bz-common.xsl bz-fo.xsl bz-html.xsl bzip.css \
		entities.xml manual.xml 

manual: manual.html manual.ps manual.pdf

manual.ps: $(MANUAL_SRCS)
	./xmlproc.sh -ps manual.xml

manual.pdf: $(MANUAL_SRCS)
	./xmlproc.sh -pdf manual.xml

manual.html: $(MANUAL_SRCS)
	./xmlproc.sh -html manual.xml

=== debian/changelog ===
bzip2 (1.0.3-6) unstable; urgency=low

  * Fixed ppc64 Build-Depends, added Build-Depends on 'libc6-dev-powerpc
    [ppc64]' in control. Patch by Andreas Jochens <aj@andaco.de>. (Closes: #384610)

 -- Santiago Ruano Rincón <santiago@debian.org>  Fri, 25 Aug 2006 11:56:44 -0500

bzip2 (1.0.3-5) unstable; urgency=low

  * 32-bit libraries installed in /usr/lib32 instead of 
    /emul/ia32-linux/usr/lib on ppc64. Patch by Andreas Jochens <aj@andaco.de> 
    (Closes: #384284)
  * Fixed doc-base control file, added Index: value for "info" format.
    (Closes: #377184)

 -- Santiago Ruano Rincón <santiago@debian.org>  Wed, 23 Aug 2006 12:31:02 -0500

bzip2 (1.0.3-4) unstable; urgency=low

  * The file of lib32bz2-1.0 and lib32bz2-dev are installed into 
    /emul/ia32-linux/usr/lib, not /usr/lib32. (Closes: #379858)

 -- Santiago Ruano Rincón <santiago@debian.org>  Tue,  8 Aug 2006 21:22:51 -0500

bzip2 (1.0.3-3) unstable; urgency=low

  * Updated co-maintainer mail address.
  * Set Standards-Version to 3.7.2.
  * Fixed "bzip2: Bug in bzgrep, with fix", closes: #374168.
  * Fixed "Superfluous symlinks in /usr", closes: #375285.
  * Fixed lintian doc-base-file-unknown-format message.
  * Synchronise with Ubuntu.
    - Fixed "build dependency ia32-libs-dev [amd64] -> libc6-dev-i386
      [amd64]", closes: #357271.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Wed, 05 Jul 2006 20:31:25 +1000

bzip2 (1.0.3-2ubuntu1) edgy; urgency=low

  * Synchronize to Debian; apply the remaining Ubuntu changes to pristine
    Debian version, since the current diffs were way too messy.
  * debian/rules:
    - Enable 32 bit libraries on amd64.
    - Do not use ia32-libs as alternative shlibs.
  * debian/control: Drop alternate build-dep on ia32-libs-dev.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 28 Jun 2006 10:31:59 +0200

bzip2 (1.0.3-2) unstable; urgency=low

  * Fixed "upgrading fails", closes: #348266. Patches by Paul Brook
    <paul@nowt.org> and Paul Wise <pabs3@bonedaddy.net>.
  * Replaces amd64-libs and amd64-libs-dev versions << 1.5.
  
 -- Anibal Monsalve Salazar <anibal@debian.org>  Mon, 16 Jan 2006 14:37:38 +1100

bzip2 (1.0.3-1) unstable; urgency=low

  * Synchronise with Ubuntu.
    - Fixed "new upstream bzip2 1.0.3 is available", closes: #318619.
    - Fixed "Please provide 64-bit packages on i386", closes: #341159.
  * Fixed "/usr/bin/$i -> /bin/$i symlinks make bzip2 break on some
    GNU/Hurd installations", closes: #346420.
  * Updated debian/copyright file.
  * Fixed linda error "File not found for field Files in doc-base file
    /usr/share/doc/bzip2/manual_*.html".
  
 -- Anibal Monsalve Salazar <anibal@debian.org>  Sun, 15 Jan 2006 10:35:23 +1100

bzip2 (1.0.3-0ubuntu1) dapper; urgency=low

  * New upstream version.
  * Synchronise with Debian unstable.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 31 Dec 2005 00:59:50 +0100

bzip2 (1.0.2-11) unstable; urgency=low

  * Fixed "Would be nice if it was installed in /bin (and /lib)",
    closes: #140157.
  * Fixed "The --color option can't be used by bzgrep", closes:
    #316028.
  * Fixed "libbz2-1.0 suggests libbz2-dev without a good reason",
    closes: #333524.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Thu, 24 Nov 2005 08:43:24 +1100

bzip2 (1.0.2-10ubuntu1) dapper; urgency=low

  * Resynchronise with Debian.
    - Still generate 64 bit packages

 -- Tollef Fog Heen <tfheen@ubuntu.com>  Thu, 10 Nov 2005 15:21:50 +0100

bzip2 (1.0.2-10) unstable; urgency=low

  * Fixed "libbz2-1.0: broken .shlibs file", closes: #330637.
  
 -- Anibal Monsalve Salazar <anibal@debian.org>  Thu, 29 Sep 2005 13:04:47 +1000

bzip2 (1.0.2-9) unstable; urgency=low

  * Acknowledge NMU, closes: #321286.
  * Fixed dependency problem, closes: #330003.
  
 -- Anibal Monsalve Salazar <anibal@debian.org>  Mon, 26 Sep 2005 23:26:55 +1000

bzip2 (1.0.2-8.1) unstable; urgency=low

  * NMU
  * Patch from Martin Pitt to bzgrep, to properly quote characters that can
    break out of the generated sed command, in analogy to the recent zgrep
    fix. Fixes CAN-2005-0758. Closes: #321286

 -- Joey Hess <joeyh@debian.org>  Sun,  4 Sep 2005 16:09:03 -0400

bzip2 (1.0.2-8) unstable; urgency=low

  * Fixed priority disparity. Changed priority from standard to important.
  * Fixed "libbz2-1.0: missing symlink", closes: #320012.
  * Changed upstream homepage, added new uploader.
  * Changed Standards-Version to 3.6.2.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sat, 30 Jul 2005 22:16:25 +1000

bzip2 (1.0.2-7ubuntu2) breezy; urgency=low

  * Build 64bit packages to replace amd64-libs.
  * Build 32bit packages on amd64 (currently disabled).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Aug 2005 16:39:17 +0200

bzip2 (1.0.2-7ubuntu1) breezy; urgency=low

  * SECURITY UPDATE: Fix shell command injection.
  * bzgrep: Properly quote characters that can break out of the generated sed
    command, in analogy to the recent zgrep fix.
  * CAN-2005-0758

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu,  4 Aug 2005 18:46:52 +0200

bzip2 (1.0.2-7) unstable; urgency=high

  * Fixed "CAN-2005-1260 decompression bomb vulnerability", closes: #310803.
    Patch by Martin Pitt <martin.pitt@ubuntu.com>.
  * Fixed "Example provided in documentation causes data loss", closes:
    #293581. Patch by Adam Borowski <kilobyte@mimuw.edu.pl>.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sat, 28 May 2005 14:05:46 +1000

bzip2 (1.0.2-6) unstable; urgency=high

  * Fixed RC bug "file permissions modification race (CAN-2005-0953)", closes:
    #303300. Patch by Santiago Ruano Rincon <santiago@unicauca.edu.co>.
    Original patch available at
    http://marc.theaimsgroup.com/?l=bugtraq&m=111352423504277&w=2

 -- Anibal Monsalve Salazar <anibal@debian.org>  Wed, 04 May 2005 17:13:20 +1000

bzip2 (1.0.2-5) unstable; urgency=low

  * Fixed "missing opening bracket in libbz2-dev.prerm" (Closes: #293673,
    #294663). Patches by Joshua Kwan <joshk@triplehelix.org> and


=== debian/control ===
Source: bzip2
Section: utils
Priority: important
Maintainer: Anibal Monsalve Salazar <anibal@debian.org>
Uploaders: Santiago Ruano Rincón <santiago@debian.org>
Standards-Version: 3.7.2
Build-depends: texinfo, libc6-dev-sparc64 [sparc], libc6-dev-s390x [s390], libc6-dev-ppc64 [powerpc], libc6-dev-i386 [amd64], libc6-dev-amd64 [i386], libc6-dev-powerpc [ppc64], lib64gcc1 [i386 powerpc sparc s390], lib32gcc1 [amd64]

Package: libbz2-1.0
Priority: important
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high-quality block-sorting file compressor library - runtime
 This package contains libbzip2 which is used by the bzip2 compressor.
 .
 bzip2 is a freely available, patent free, high-quality data compressor. 
 It typically compresses files to within 10% to 15% of the best available
 techniques, whilst being around twice as fast at compression and six
 times faster at decompression.
 .
 bzip2 compresses files using the Burrows-Wheeler block-sorting text
 compression algorithm, and Huffman coding. Compression is generally
 considerably better than that achieved by more conventional
 LZ77/LZ78-based compressors, and approaches the performance of the PPM
 family of statistical compressors.
 .
 The archive file format of bzip2 (.bz2) is incompatible with that of its
 predecessor, bzip (.bz).
 .
  Homepage: http://www.bzip.org/

Package: libbz2-dev
Priority: optional
Section: libdevel
Architecture: any
Depends: libbz2-1.0 (=${Source-Version}), libc6-dev | libc-dev
Replaces: bzip2 (<<0.9.5d-3)
Description: high-quality block-sorting file compressor library - development
 Static libraries and include files for the bzip2 compressor library.
 .
 bzip2 is a freely available, patent free, high-quality data compressor. 
 It typically compresses files to within 10% to 15% of the best available
 techniques, whilst being around twice as fast at compression and six
 times faster at decompression.
 .
 bzip2 compresses files using the Burrows-Wheeler block-sorting text
 compression algorithm, and Huffman coding.  Compression is generally
 considerably better than that achieved by more conventional
 LZ77/LZ78-based compressors, and approaches the performance of the PPM
 family of statistical compressors.
 .
 The archive file format of bzip2 (.bz2) is incompatible with that of its
 predecessor, bzip (.bz).
 .
  Homepage: http://www.bzip.org/

Package: bzip2
Priority: optional
Section: utils
Architecture: any
Depends: libbz2-1.0 (=${Source-Version})
Replaces: libbz2 (<<0.9.5d-3)
Description: high-quality block-sorting file compressor - utilities
 bzip2 is a freely available, patent free, high-quality data compressor. 
 It typically compresses files to within 10% to 15% of the best available
 techniques, whilst being around twice as fast at compression and six
 times faster at decompression.
 .
 bzip2 compresses files using the Burrows-Wheeler block-sorting text
 compression algorithm, and Huffman coding.  Compression is generally
 considerably better than that achieved by more conventional
 LZ77/LZ78-based compressors, and approaches the performance of the PPM
 family of statistical compressors.
 .
 The archive file format of bzip2 (.bz2) is incompatible with that of its
 predecessor, bzip (.bz).
 .
  Homepage: http://www.bzip.org/

Package: lib64bz2-1.0
Priority: optional
Section: libs
Architecture: i386 powerpc sparc s390
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: amd64-libs (<< 1.5)
Description: high-quality block-sorting file compressor library - 64bit runtime
 This package contains the libbzip2 64bit runtime library.
 .
  Homepage: http://www.bzip.org/

Package: lib64bz2-dev
Priority: optional
Section: libdevel
Replaces: amd64-libs-dev (<< 1.5)
Architecture: i386 powerpc sparc s390
Depends: lib64bz2-1.0 (=${Source-Version}), libbz2-dev (=${Source-Version}), ${dev:Depends}
Description: high-quality block-sorting file compressor library - 64bit development
 Static libraries and include files for the bzip2 compressor library (64bit).
 .
  Homepage: http://www.bzip.org/

Package: lib32bz2-1.0
Priority: optional
Section: libs
Architecture: amd64 ppc64
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: ia32-libs
Description: high-quality block-sorting file compressor library - 32bit runtime
 This package contains the libbzip2 32bit runtime library.
 .
  Homepage: http://www.bzip.org/

Package: lib32bz2-dev
Priority: optional
Section: libdevel
Architecture: amd64 ppc64
Depends: lib32bz2-1.0 (=${Source-Version}), libbz2-dev (=${Source-Version}), ${dev:Depends}
Replaces: ia32-libs-dev
Description: high-quality block-sorting file compressor library - 32bit development
 Static libraries and include files for the bzip2 compressor library (32bit).
 .
  Homepage: http://www.bzip.org/

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for building the Debian GNU/Linux package bzip2.
# Copyright (C) 1999, 2000, 2001, 2002 Philippe Troin
# Copyright (C) 2004-2006 Anibal Monsalve Salazar <anibal@debian.org>

SHELL = /bin/bash
package = bzip2

testdir=test -x debian/rules && test -f bzip2.c
testroot=test "`id -nu`" = root

DEB_BUILD_GNU_TYPE	:= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE	:= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH		:= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS	:= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

DEBCFLAGS:=
DEBSTRIP:=strip
WGET=wget
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
DEBCFLAGS += -g
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
DEBSTRIP:=:
endif

DEBVERSION:=$(shell head -n 1 debian/changelog \
		    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
UPVERSION:=$(shell echo $(DEBVERSION) | sed -e 's/-[0-9.]*$$//')

ifneq (,$(findstring /$(DEB_HOST_ARCH)/,/i386/powerpc/sparc/s390/))
	build64-stamp := build64-stamp
	CC64=gcc -m64
endif
ifeq ($(DEB_HOST_ARCH),i386)
	CC64 += -march=x86-64 -mtune=x86-64
endif

ifneq (,$(findstring /$(DEB_HOST_ARCH)/,/amd64/ppc64/))
	build32-stamp := build32-stamp
	ifneq (,$(findstring /$(DEB_HOST_ARCH)/,/amd64/))
		lib32 := emul/ia32-linux/usr/lib
	else
		lib32 := usr/lib32
	endif
endif

build: build-stamp $(build32-stamp) $(build64-stamp)
build-stamp:
	$(testdir)
	# Add here commands to compile the package.
	$(MAKE) DEBCFLAGS="$(DEBCFLAGS)"
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	$(MAKE) DEBCFLAGS="$(DEBCFLAGS)" test
endif
	makeinfo -o bzip2.info manual.texi
	cat debian/copyright.in LICENSE > debian/copyright
	touch build-stamp

# requires: docbook-xml docbook2x
manual.texi: manual.xml
	docbook2x-texi --to-stdout manual.xml | \
	awk '/^@direntry/,/^@end direntry/ {if ($$0 !~ /@/) {print "* Bzip2: (bzip2).               A program and library for data compression."; next}} {print}' > manual.texi

build32: build32-stamp
build32-stamp:
	$(testdir)
	rm -rf 32
	mkdir 32
	cp -p *.h *.c Makefile 32/
	$(MAKE) -C 32 CC="gcc -m32" DEBCFLAGS="$(DEBCFLAGS)"
	touch build32-stamp

build64: build64-stamp
build64-stamp:
	$(testdir)
	rm -rf 64
	mkdir 64
	cp -p *.h *.c Makefile 64/
	$(MAKE) -C 64 CC="$(CC64)" DEBCFLAGS="$(DEBCFLAGS)"
	touch build64-stamp


clean:
	$(testdir)
	rm -f build*-stamp
	-$(MAKE) clean
	rm -rf 32 64
	rm -f debian/substvars debian/files debian/copyright bzip2.info*
	rm -fr debian/tmp*
	find . -name "*~" -print0 | xargs -r0 rm -f

# Build architecture-independent files here.
binary-indep: build
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build
	$(testdir)
	$(testroot)
	rm -fr debian/tmp*
	install -d debian/tmp/usr

	$(MAKE) PREFIX=`pwd`/debian/tmp install

	### Split

	# Development package
	install -d debian/tmp-dev/usr/lib
	rm debian/tmp/lib/libbz2.so
	ln -s /lib/libbz2.so.1.0 debian/tmp-dev/usr/lib/libbz2.so
	mv debian/tmp/lib/libbz2.a debian/tmp-dev/usr/lib/
	mv debian/tmp/include debian/tmp-dev/usr/include
	

	# Library package
	install -d debian/tmp-lib/lib
	for i in $$(ls debian/tmp/lib/libbz2.so*); do \
	  (set -x; echo $$i; mv $$i debian/tmp-lib/lib/); \
	done
	ln -s libbz2.so.1.0.3 debian/tmp-lib/lib/libbz2.so.1
	chmod -x debian/tmp-lib/lib/*

	# Binary package
	install -d debian/tmp-run
	mv debian/tmp/bin debian/tmp-run/bin
	install -d debian/tmp-run/usr/share
	mv debian/tmp/man debian/tmp-run/usr/share/man

	### Check the install
	test "$$(find debian/tmp ! -type d -print | wc -l)" -eq 0
	rm -fr debian/tmp

	### Finalize documentation

	# Man pages
	gzip -v9 debian/tmp-run/usr/share/man/man1/*.1
	( cd debian/tmp-run/usr/share/man/man1 && \
	  for i in bunzip2 bzcat bzip2recover; do \
	    ln -s bzip2.1.gz $$i.1.gz; \
	  done )

	# Info
	install -d debian/tmp-run/usr/share/info
	cp bzip2.info* debian/tmp-run/usr/share/info/
	gzip -v9 debian/tmp-run/usr/share/info/*

	# Other docs in lib package
	install -d debian/tmp-run/usr/share/doc/bzip2
	cp *.ps *.html *.texi debian/tmp-run/usr/share/doc/bzip2
	gzip -v9 debian/tmp-run/usr/share/doc/bzip2/*.{ps,texi}
	cp CHANGES debian/tmp-run/usr/share/doc/bzip2/changelog
	cp debian/changelog \
	  debian/tmp-run/usr/share/doc/bzip2/changelog.Debian
	gzip -v9 debian/tmp-run/usr/share/doc/bzip2/changelog*
	cp debian/copyright debian/tmp-run/usr/share/doc/bzip2/

	# Doc-base support
	install -d debian/tmp-run/usr/share/doc-base
	cp debian/docbase debian/tmp-run/usr/share/doc-base/bzip2

	# Library package
	install -d debian/tmp-lib/usr/share/doc/libbz2-1.0
	cp debian/copyright debian/tmp-lib/usr/share/doc/libbz2-1.0/
	cp CHANGES debian/tmp-lib/usr/share/doc/libbz2-1.0/changelog
	cp debian/changelog \
	  debian/tmp-lib/usr/share/doc/libbz2-1.0/changelog.Debian
	gzip -v9 debian/tmp-lib/usr/share/doc/libbz2-1.0/changelog*

	# Other packages point to libbz2-1.0
	install -d debian/tmp-dev/usr/share/doc
	ln -s libbz2-1.0 debian/tmp-dev/usr/share/doc/libbz2-dev

	### Package finalize

	# Stripping
	for i in debian/tmp-run/bin/*; \
	do \
	  if head -n 1 $$i | grep -vq '^#!'; \
	  then \
	    (set -x; $(DEBSTRIP) -R .note -R .comment $$i); \
	  fi; \
	done
	$(DEBSTRIP) --strip-unneeded -R .note -R .comment \
	  debian/tmp-lib/lib/*.so*
	$(DEBSTRIP) --strip-debug debian/tmp-dev/usr/lib/*.a

	# Control files
	install -d debian/tmp-{lib,dev,run}/DEBIAN
	cp debian/shlibs debian/tmp-lib/DEBIAN/shlibs

	dpkg-shlibdeps debian/tmp-lib/lib/*.so*
	dpkg-gencontrol -isp -Pdebian/tmp-lib -plibbz2-1.0
	rm debian/substvars
	dpkg-gencontrol -isp -Pdebian/tmp-dev -plibbz2-dev
	dpkg-shlibdeps debian/tmp-run/bin/*
	dpkg-gencontrol -isp -Pdebian/tmp-run -pbzip2

	for i in run dev lib; do \
	  cp debian/postinst-$$i debian/tmp-$$i/DEBIAN/postinst; \
	  cp debian/prerm-$$i debian/tmp-$$i/DEBIAN/prerm; \
	  chmod +x debian/tmp-$$i/DEBIAN/postinst; \
	  chmod +x debian/tmp-$$i/DEBIAN/prerm; \
	done
	cp debian/preinst-run debian/tmp-run/DEBIAN/preinst
	cp debian/postrm-lib debian/tmp-lib/DEBIAN/postrm
	chmod +x debian/tmp-run/DEBIAN/preinst debian/tmp-lib/DEBIAN/postrm

	# Fix perms
	chown -R root.root debian/tmp*
	chmod -R a+rX-wts,u+w debian/tmp*

	# Buildit
	dpkg --build debian/tmp-run ..
	dpkg --build debian/tmp-lib ..
	dpkg --build debian/tmp-dev ..

ifneq (,$(build64-stamp))
	rm -rf debian/tmp-lib64
	rm -rf debian/tmp-dev64

	install -d debian/tmp-lib64/usr/lib64
	cp -a 64/libbz2.so.* debian/tmp-lib64/usr/lib64/
	chmod -x debian/tmp-lib64/usr/lib64/*

	install -d debian/tmp-dev64/usr/lib64
	cp -a 64/libbz2.so 64/libbz2.a debian/tmp-dev64/usr/lib64/
	chmod -x debian/tmp-dev64/usr/lib64/*

	install -d debian/tmp-lib64/usr/share/doc/lib64bz2-1.0
	cp debian/copyright debian/tmp-lib64/usr/share/doc/lib64bz2-1.0/
	cp debian/changelog \
	  debian/tmp-lib64/usr/share/doc/lib64bz2-1.0/changelog.Debian
	gzip -v9 debian/tmp-lib64/usr/share/doc/lib64bz2-1.0/changelog*

	install -d debian/tmp-dev64/usr/share/doc
	ln -s lib64bz2-1.0 debian/tmp-dev64/usr/share/doc/lib64bz2-dev

	$(DEBSTRIP) --strip-unneeded -R .note -R .comment \
	  debian/tmp-lib64/usr/lib64/*.so*
	$(DEBSTRIP) --strip-debug debian/tmp-dev64/usr/lib64/*.a

	install -d debian/tmp-{lib,dev}64/DEBIAN
	/bin/echo -e 'libbz2\t1.0\tlib64bz2-1.0' > debian/tmp-lib64/DEBIAN/shlibs

	-dpkg-shlibdeps debian/tmp-lib/usr/lib64/*.so*
ifeq ($(DEB_HOST_ARCH),i386)
	echo 'shlibs:Depends=libc6-amd64' > debian/substvars
endif
ifeq ($(DEB_HOST_ARCH),powerpc)
	echo 'shlibs:Depends=libc6-ppc64' > debian/substvars
endif
#ifeq ($(DEB_HOST_ARCH),s390)
#	echo 'shlibs:Depends=libc6-s390x' > debian/substvars
#endif
#ifeq ($(DEB_HOST_ARCH),sparc)
#	echo 'shlibs:Depends=libc6-sparc64' > debian/substvars
#endif
	dpkg-gencontrol -isp -Pdebian/tmp-lib64 -plib64bz2-1.0
	rm -f debian/substvars

ifeq ($(DEB_HOST_ARCH),i386)
	echo 'dev:Depends=libc6-dev-amd64' > debian/substvars
endif
ifeq ($(DEB_HOST_ARCH),powerpc)
	echo 'dev:Depends=libc6-dev-ppc64' > debian/substvars
endif
ifeq ($(DEB_HOST_ARCH),s390)
